<?php

declare(strict_types=1);

use Symfony\Component\DependencyInjection\Loader\Configurator\ContainerConfigurator;
use Symfony\Config\FrameworkConfig;

return static function (ContainerConfigurator $containerConfigurator, FrameworkConfig $config): void {
	$config->handleAllThrowables(true);

	$config->annotations([
		'enabled' => FALSE
	]);

	$config->session([
		'handler_id' => NULL,
		'cookie_secure' => 'auto',
		'cookie_samesite' => 'strict',
	]);

	$config->secret('%env(APP_SECRET)%')
		->defaultLocale('en')
		->httpMethodOverride(TRUE)
		->phpErrors(['log' => TRUE]);
};
