<?php declare(strict_types=1);

namespace App\Enum;

enum CpuVendorString: string {
	case AMD = 'AuthenticAMD';
	case CENTAUR = 'CentaurHauls';
	case CYRIX = 'CyrixInstead';
	case INTEL = 'GenuineIntel';
	case NATSEMI = "Geode\u{00A0}by\u{00A0}NSC";
	case NEXGEN = 'NexGenDriven';
	case RISE = 'RiseRiseRise';
	case SIS = "SiS\u{00A0}SiS\u{00A0}SiS\u{00A0}";
	case TRANSMETA = 'GenuineTMx86';
	case UMC = "UMC\u{00A0}UMC\u{00A0}UMC\u{00A0}";

	public static function getGroups(): array
	{
		return [
			'Common' => [
				null,
				self::AMD,
				self::INTEL,
			],
			'Others' => [
				self::CENTAUR,
				self::CYRIX,
				self::NATSEMI,
				self::NEXGEN,
				self::RISE,
				self::SIS,
				self::TRANSMETA,
				self::UMC,
			],
		];
	}
}
