<?php declare(strict_types=1);

namespace App\Form;

use App\Entity\{Brand, Chipset};
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\{AbstractType, FormBuilderInterface};
use Symfony\Component\OptionsResolver\OptionsResolver;

class ChipsetType extends AbstractType {
	use FormHelperTrait;

	public function buildForm(FormBuilderInterface $builder, array $options): void
	{
		$builder
			->add('brand', EntityType::class, [
				'class' => Brand::class,
				'query_builder' => self::filterBrands('chipset'),
			])
			->add('name')
			->add('parts')
			->add('link');
	}

	public function configureOptions(OptionsResolver $resolver): void
	{
		$resolver->setDefaults([
			'data_class' => Chipset::class,
		]);
	}
}
