<?php declare(strict_types=1);

namespace App\Form;

use Doctrine\ORM\{EntityRepository, QueryBuilder};

trait FormHelperTrait {
	public static function filterBrands(string $filter): callable
	{
		return static fn (EntityRepository $e) => $e->createQueryBuilder('b')
			->join('b.categories', 'bc')
			->where('bc.name=:name')
			->orderBy('b.name', 'ASC')
			->setParameter('name', $filter);
	}

	public static function getSocketBrands(): callable
	{
		return static fn (EntityRepository $e) => $e->createQueryBuilder('b')
			->join('b.categories', 'bc')
			->where('bc.name=:name1')
			->orWhere('bc.name=:name2')
			->orderBy('b.name', 'ASC')
			->setParameter('name1', 'cpu')
			->setParameter('name2', 'fpu');
	}

	public static function getSockets(): callable
	{
		return static fn (EntityRepository $e) => $e->createQueryBuilder('s')
			->leftJoin('s.brand', 'sb')
			->orderBy('sb.name', 'ASC')
			->addOrderBy('s.pinCount', 'ASC')
			->addOrderBy('s.name', 'ASC');
	}
}
